package com.ruoyi.tc.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.tc.baseClass.BaseClass;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.io.Serializable;
import java.util.Date;

/**
 * 小程序资产表(asset_mini_programs)实体类
 *
 * @author du
 * @since 2024/11/13 14:44
 */
@Data
@ApiModel("小程序资产表")
@TableName(value = "asset_mini_programs")
public class AssetMiniPrograms extends BaseClass implements Serializable {

    /**
    * 
    */
    @ApiModelProperty("id")
    @TableId(value = "id",type = IdType.AUTO)
    private Long id;

    @ApiModelProperty("组织机构名称（部门名称）")
    @TableField(exist = false)
    private String deptName;
    /**
    * 所属单位
    */
    @Excel(name = "所属单位", sort = 1, width = 22)
    @ApiModelProperty("所属单位")
    private String ssdw;
    /**
    * 小程序名称
    */
    @Excel(name = "小程序名称", sort = 2, width = 22)
    @ApiModelProperty("小程序名称")
    private String xcxmc;
    /**
    * appid
    */
    @Excel(name = "APPID", sort = 3, width = 22)
    @ApiModelProperty("appid")
    private String appId;
    /**
    * 认证主体
    */
    @Excel(name = "认证主体", sort = 4, width = 26)
    @ApiModelProperty("认证主体")
    private String rzzt;
    /**
    * 统一社会信用代码
    */
    @Excel(name = "统一社会信用代码", sort = 5)
    @ApiModelProperty("统一社会信用代码")
    private String tyshxydm;
    /**
    * 小程序状态（字典）
    */
    @Excel(name = "小程序状态", sort = 6,dictType = "gzh_state",comboReadDict = true)
    @ApiModelProperty("小程序状态（字典）")
    private String state;
    /**
    * 账号原始ID
    */
    @Excel(name = "账号原始ID", sort = 7)
    @ApiModelProperty("账号原始ID")
    private String ysId;
    /**
    * 小程序包状态(字典)
    */
    @Excel(name = "小程序包状态", sort = 8,dictType = "email_state",comboReadDict = true)
    @ApiModelProperty("小程序包状态(字典)")
    private String packState;
    /**
    * 认证状态(字典）
    */
    @Excel(name = "认证状态", sort = 9,dictType = "gzh_rzzt",comboReadDict = true)
    @ApiModelProperty("认证状态(字典）")
    private String rzState;
    /**
    * 认证时间
    */
    @Excel(name = "认证时间", sort = 10)
    @ApiModelProperty("认证时间")
    private String rzsj;
    /**
    * 认证类型（字典）
    */
    @Excel(name = "认证类型", sort = 11,dictType = "gzh_rzlx",comboReadDict = true)
    @ApiModelProperty("认证类型（字典）")
    private String rzlx;
    /**
    * icp备案状态
    */
    @ApiModelProperty("icp备案状态")
    @Excel(name = "icp备案状态", sort = 12)
    private String icpState;
    /**
    * 域命白名单
    */
    @Excel(name = "域名白名单", sort = 13)
    @ApiModelProperty("域命白名单")
    private String ymbmd;
    /**
    * 服务类目
    */
    @Excel(name = "服务类目", sort = 14)
    @ApiModelProperty("服务类目")
    private String fwlm;
    /**
    * 行业电子邮箱
    */
    @Excel(name = "行业电子邮箱", sort = 15)
    @ApiModelProperty("行业电子邮箱")
    private String hydzyx;
    /**
    * 所属行业（字典）
    */
    @ApiModelProperty("所属行业（字典）")
    @Excel(name = "所属行业",dictType = "app_sshy",comboReadDict = true,sort = 16, width = 18)
    private String sshy;
    /**
    * 重点行业(字典)
    */
    @Excel(name = "重点行业",dictType = "app_zdhy",comboReadDict = true,sort = 17, width = 18)
    @ApiModelProperty("重点行业(字典)")
    private String zdhy;
    /**
    * 行政区划（字典)
    */
    @Excel(name = "行政区划",dictType = "app_xzqh",comboReadDict = true,sort = 18, width = 18)
    @ApiModelProperty("行政区划（字典)")
    private String xzqh;
    /**
    * 系统简介
    */
    @Excel(name = "系统简介",sort = 19, width = 24)
    @ApiModelProperty("系统简介")
    private String xtjj;
    /**
    * 系统责任人
    */
    @Excel(name = "系统责任人",sort = 20)
    @ApiModelProperty("系统责任人")
    private String xtzrr;
    /**
    * 系统责任人电话
    */
    @Excel(name = "系统责任人电话",sort = 21)
    @ApiModelProperty("系统责任人电话")
    private String xtzrrdh;
    /**
    * 系统责任人邮箱
    */
    @Excel(name = "系统责任人邮箱",sort = 22)
    @ApiModelProperty("系统责任人邮箱")
    private String xtzrryx;
    /**
    * 系统责任人地址
    */
    @Excel(name = "系统责任人地址",sort = 23,width = 24)
    @ApiModelProperty("系统责任人地址")
    private String xtzrrdz;
    /**
    * 引用插件appid
    */
    @Excel(name = "引用插件（APPID）",sort = 24)
    @ApiModelProperty("引用插件appid")
    private String yycjAppid;
    /**
    * 引用插件开发者
    */
    @Excel(name = "引用插件（开发者）",sort = 25)
    @ApiModelProperty("引用插件开发者")
    private String yycjKfz;
    /**
    * 删除标志（0代表存在 2代表删除）
    */
    @ApiModelProperty("删除标志（0代表存在 2代表删除）")
    private String delFlag;



    @ApiModelProperty("是否报废")
    private Integer isbf=0;

    /**
     * 审核
     */
    @ApiModelProperty("审核")
    @TableField(exist = false)
    private String auditState;
}
