package com.ruoyi.tc.entity.po;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.ruoyi.tc.baseClass.BaseClass;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * 资产基础网络复制表(asset_basic_network)实体类
 *
 * @author du
 * @since 2024/11/13 14:44
 */
@Data
@ApiModel("资产基础网络复制表")
@TableName(value = "asset_basic_network_cp")
public class AssetBasicNetworkCpPo extends BaseClass implements Serializable {
    /**
     * 主键id
     */
    @TableId(type = IdType.AUTO, value = "network_id")
    private Long networkId;


    /**
     * 资源id
     */
    @ApiModelProperty("资源id")
    private Long assetId;
    /**
     * 1.服务器信息2网络设备3安全设备
     */
    @NotNull
    @ApiModelProperty("1.服务器信息2网络设备3安全设备")
    private Integer type;
    /**
     * 设备类型
     */

    @ApiModelProperty("设备类型")
    private String sblx;
    /**
     * 品牌
     */

    @ApiModelProperty("品牌")
    private String pp;
    /**
     * 设备IP
     */

    @ApiModelProperty("设备IP")
    private String sbIp;
    /**
     * 操作系统
     */

    @ApiModelProperty("操作系统")
    private String czxt;
    /**
     * 操作系统版本
     */

    @ApiModelProperty("操作系统版本")
    private String czxtbb;
    /**
     * 硬件型号
     */

    @ApiModelProperty("硬件型号")
    private String yjxh;
    /**
     * 硬件序列号
     */

    @ApiModelProperty("硬件序列号")
    private String yjxlh;
    /**
     * 硬件版本信息
     */

    @ApiModelProperty("硬件版本信息")
    private String yjbbxx;
    /**
     * 硬件用途
     */

    @ApiModelProperty("硬件用途")
    private String yjyt;
    /**
     * 硬件部署位置
     */

    @ApiModelProperty("硬件部署位置")
    private String yjbsxx;

    @ApiModelProperty("删除标志（0代表存在 2代表删除）")
    private String delFlag;

    @ApiModelProperty("任务id")
    private Integer taskId;

    /**
     * 设备IP类型
     */
    @ApiModelProperty("设备IP类型")
    private String ipType;
}
