package com.ruoyi.tc.entity.request;

import com.ruoyi.tc.entity.po.*;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.Valid;

/**
 * @author dong
 * @since 2024/11/20 16:29
 */
@Data
@ApiModel("管理端审核请求类")
public class AssetCurrentShRequest {

    /**
     * 任务id
     */
    @ApiModelProperty("任务id")
    private Integer taskId;


    /**
     * 资产类型
     */
    @ApiModelProperty("0:web资产，1:小程序资产，2：公众号资产，3：电子邮件资产，4：移动应用程序资产")
    private Integer type;

    /**
     * 系统名称
     */
    @ApiModelProperty("系统名称")
    private String xtmc;


    /**
     * 单位名称
     */
    @ApiModelProperty("单位名称")
    private String dwmc;

    /**
     * 资产id
     */
    @ApiModelProperty("资产id")
    private Integer assetId;

    /**
     * 不通过原因
     */
    @ApiModelProperty("不通过原因")
    private String btgyy;

    /**
     * 审核状态（0待核查，1待审核，3审核通过，4审核不通过，5已报废）
     */
    @ApiModelProperty("审核状态（0待核查，1待审批，3审核通过，4审核不通过，5已报废）")
    private Integer status;

    /**
     * app
     */
    @ApiModelProperty("app")
    @Valid
    private AssetAppCpPo assetAppCpPo;

    /**
     * web
     */
    @ApiModelProperty("web")
    @Valid
    private AssetCurrentCpPo assetCurrentCpPo;

    /**
     * 小程序
     */
    @ApiModelProperty("小程序")
    @Valid
    private AssetMiniProgramsCpPo assetMiniProgramsCpPo;

    /**
     * 小程序
     */
    @ApiModelProperty("公众号")
    @Valid
    private AssetOfficialAccountCpPo assetOfficialAccountCpPo;

    /**
     * 邮件
     */
    @ApiModelProperty("邮件")
    @Valid
    private AssetEmailCpPo assetEmailCpPo;

}
