package com.ruoyi.tc.entity.request;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * 小程序资产分页查询请求类
 * @author du
 * @since 2024/11/15 15:37
 */
@Data
public class AssetMiniProgramsPageRequest {


    @ApiModelProperty("组织机构代码")
    private Long deptId;


    /**
     * 系统状态
     */
    @ApiModelProperty("系统状态")
    private String xtzt;

    /**
     * 小程序名称
     */
    @ApiModelProperty("小程序名称")
    private String xcxmc;

    /**
     * 所属单位
     */
    @ApiModelProperty("所属单位")
    private String dwmc;


    /**
     * 开始时间
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("开始时间")
    private Date startTime;

    /**
     * 结束时间
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("结束时间")
    private Date endTime;

    @ApiModelProperty("页码")
    private Long current=1L;

    @ApiModelProperty("页数")
    private Long size=10L;
}
