package com.ruoyi.tc.entity.response;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

/**
 * @author dong
 * @since 2024/11/19 15:09
 */
@Data
@ApiModel("资产核查响应类")
public class AssestTaskXqresponse {

    /**
     * 资产id
     */
    @ApiModelProperty("资产id")
    private Integer id;
    /**
     * 任务id
     */
    @ApiModelProperty("任务id")
    private Integer taskId;
    /**
     * 系统类型
     */
    @ApiModelProperty("系统类型")
    private String xtlx;

    /**
     * 系统名称
     */
    @ApiModelProperty("系统名称")
    private String xtmc;


    /**
     * 资产单位名称
     */
    @ApiModelProperty("资产单位名称")
    private String zcdwmc;


    /**
     * 审核状态（0待核查，1待审核，3审核通过，4审核不通过，5已报废）
     */
    @ApiModelProperty("审核状态（0待核查，1待审核，3审核通过，4审核不通过，5已报废）")
    private String status;


    /**
     * 不通过原因
     */
    @ApiModelProperty("不通过原因")
    private String btgyy;


    /**
     * 单位核查时间
     */
    @ApiModelProperty("单位核查时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime updateTime;
}
