package com.ruoyi.tc.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.tc.entity.po.AssetAppCpPo;
import com.ruoyi.tc.entity.po.AssetMiniProgramsCpPo;
import com.ruoyi.tc.entity.po.AssetOfficialAccountCpPo;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.util.List;

/**
 * 公众号资产表(asset_official_account_cp)表数据库访问层
 *
 * @author makejava
 * @since 2024-11-15 10:03:56
 */
public interface AssetOfficialAccountCpMapper extends BaseMapper<AssetOfficialAccountCpPo> {

    /**
     * 根据资产id和任务id删除数据
     *
     * @param assetId 资产id
     * @param taskId  任务id
     */
    @Delete("delete from asset_official_account_cp where asset_id=#{assetId} and task_id =#{taskId}  ")
    void deletByAssetIdandTaskId(@Param("assetId") Long assetId, @Param("taskId") Integer taskId);


    /**
     * 根据taskid查询查询数据
     *
     * @param taskId 任务id
     * @return
     */
    @Select("select * from  asset_official_account_cp where task_id=#{taskId}")
    List<AssetOfficialAccountCpPo> findByTaskId(@Param("taskId") int taskId);



    /**
     * 修改不通过原因
     *
     * @param assetId 资产id
     * @param taskId 任务id
     * @param btgyy 不通过原因
     */
    @Update("update asset_official_account_cp set btgyy=#{btgyy},count=#{newThcs} where asset_id=#{assetId} and task_id =#{taskId} ")
    void updateByAssetId(@Param("assetId") Integer assetId, @Param("taskId") Integer taskId, @Param("btgyy")String btgyy,@Param("newThcs") Integer newThcs);




    /**
     * 根据任务id,资产id获取退回次数
     *
     * @param assetId 资产id
     * @param taskId  任务id
     * @return
     */
    @Select("select * from  asset_official_account_cp where asset_id=#{assetId} and task_id =#{taskId} ")
    AssetOfficialAccountCpPo findByassetIdandTaskId(@Param("assetId") Integer assetId, @Param("taskId") Integer taskId);


    /**
     * 根据资产id查询资产
     *
     * @param id
     * @return
     */
    @Select(" select * from  asset_official_account_cp  where asset_id = #{id} ")
    AssetOfficialAccountCpPo findDwmc(Long id);
}

