package com.ruoyi.tc.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.tc.entity.AssetApp;
import com.ruoyi.tc.entity.AssetEmail;
import com.ruoyi.tc.entity.po.AssetCurrentCpPo;
import com.ruoyi.tc.entity.request.AssetAppPageRequest;
import com.ruoyi.tc.entity.request.AssetEmailPageRequest;

import java.util.List;

/**
 * 电子邮件资产表(asset_email)表服务接口
 *
 * @author makejava
 * @since 2024-11-28 17:13:07
 */
public interface AssetEmailService extends IService<AssetEmail> {
    /**
     * 分页查询所有数据
     *
     * @param page 分页对象
     * @param as   查询实体
     * @return 所有数据
     */
    Page<AssetEmail> page(Page<AssetEmail> page, AssetEmailPageRequest as);

    /**
     * 逻辑删除
     */
    void deleteById(Long id);

    /**
     * 查询所有数据
     *
     * @param as   查询实体
     * @return 所有数据
     */
    List<AssetEmail> getAllList(AssetEmailPageRequest as);


    /**
     * 删除
     * @param idList
     */
    void deleteIdList(List<Long> idList);



    /**
     * 根据单位查询资产总数
     *
     * @param part 单位
     * @return
     */
    Integer findBydwmc(String part);

    /**
     * 新增email数据
     *
     * @param assetEmail 实体
     * @return 新增结果
     */
    Boolean add(AssetEmail assetEmail);

    /**
     * 编辑email数据
     *
     * @param assetEmail 实体
     * @return 编辑结果
     */
    Boolean edit(AssetEmail assetEmail);
}

