package com.ruoyi.tc.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.tc.entity.po.AssetMiniProgramsCpPo;
import com.ruoyi.tc.entity.po.AssetOfficialAccountCpPo;

import java.util.List;

/**
 * 公众号资产(asset_official_account_cp)表服务接口
 *
 * @author makejava
 * @since 2024-11-28 17:13:07
 */
public interface AssetOfficialAccountCpService extends IService<AssetOfficialAccountCpPo> {

    /**
     * 根据资产id和任务id删除数据
     *
     * @param assetId 资产id
     * @param taskId  任务id
     */
    void deletByAssetIdandTaskId(Long assetId, Integer taskId);


    /**
     * 根据taskid查询查询数据
     *
     * @param taskId 任务id
     * @return
     */
    List<AssetOfficialAccountCpPo> findByTaskId(int taskId);

    /**
     * 修改不通过原因
     *
     * @param assetId 资产id
     * @param taskId  任务id
     * @param btgyy   不通过原因
     * @param newThcs 不通过次数
     */
    void updateByAssetId(Integer assetId, Integer taskId, String btgyy, Integer newThcs);

    /**
     * 根据任务id,资产id获取退回次数
     *
     * @param assetId 资产id
     * @param taskId  任务id
     * @return
     */
    AssetOfficialAccountCpPo findByassetIdandTaskId(Integer assetId, Integer taskId);


    /**
     * 根据资产id查询资产
     *
     * @param id
     * @return
     */
    AssetOfficialAccountCpPo findDwmc(Long id);
}
