package com.ruoyi.tc.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ruoyi.tc.entity.po.AssetSupplyChainCpPo;
import com.ruoyi.tc.entity.po.UnitOtherConcatCpPo;
import com.ruoyi.tc.entity.po.UnitOtherConcatJyPo;

import java.util.List;

/**
 * 单位其他联系人复制(unit_other_contact_cp)业务层
 * @author du
 * @since 2024/11/13 14:55
 */
public interface UnitOtherConcatCpService extends IService<UnitOtherConcatCpPo> {

    /**
     * 根据资产id资产供应链原有id
     *
     * @param assetId 资产id
     * @return
     */
    List<UnitOtherConcatCpPo> findByassetId(Long assetId);


    /**
     * 根据资产id和任务id删除数据
     *
     * @param assetId 资产id
     * @param taskId  任务id
     */
    void deletByAssetIdandTaskId(Long assetId, Integer taskId);



    /**
     * 根据taskid查询查询数据
     *
     * @param taskId 任务id
     * @return
     */
    List<UnitOtherConcatCpPo> findByTaskId(int taskId);
}
